//Description: This script makes the r.a.d.grid reorder 
//			   columns instead of swapping them
//Author:	   Philip Wolfe (http://www.philipwolfe.com)


//variable to hold the grid to trap column swapping
var theGrid;

//this function is bound to the clientevent OnGridCreated
function RadGrid1_OnGridCreated()
{
	//get a reference to the grid that was just created
	theGrid = this;
}

//this variable will track if we are currently reordering
var reordering = false;

//this function is bound to the clientevent OnColumnSwapping
function RadGrid1_OnColumnSwapping(columnIndex1, columnIndex2)
{
	if(!reordering)
	{
		//if reordering is not occuring then it is possible to reorder the columns
		
		//turn on reordering
		reordering = true;
		
		//initiate a function on a different "thread" because 
		//OnColumnSwapping will be called as the columns are reordered
		setTimeout('ReorderColumns(' + columnIndex1 + ', ' + columnIndex2 + ')', 10);
	}
}

//This function will reorder columns given a newIndex and oldIndex
//It assumes that the initial ColumnSwap was successful
function ReorderColumns(newIndex, oldIndex)
{
	if(newIndex == oldIndex)
	{
		//do nothing if the indexes are the same
		return;
	}			
	else if(oldIndex > newIndex)
	{
		//the old index is greater so the column must move down
		
		//loop until the old index is equal to the column before the new index
		while(newIndex + 1 < oldIndex)
		{
			//swap columns of oldIndex and the column before oldIndex
			theGrid.MasterTableView.SwapColumns(oldIndex-1, oldIndex);
			//now the oldIndex column has moved down so decrement the index
			oldIndex--;
		}
	}
	else
	{
		//the old index is less so the column must move up
		
		//loop until the old index is equal to the column before the new index
		while(oldIndex < newIndex - 1)
		{
			//swap columns of oldIndex and the column after oldIndex
			theGrid.MasterTableView.SwapColumns(oldIndex+1, oldIndex);
			//now the oldIndex column has moved up so increment the index
			oldIndex++;
		}
	}
	
	//reordering is done so turn off reordering
	reordering = false;
}
</script>